<!DOCTYPE html>
<html class="writer-html5" lang="en">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>nl2declare.utils.word_classes &mdash; NL2Declare  documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css" />

  
  <!--[if lt IE 9]>
    <script src="../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../" id="documentation_options" src="../../../_static/documentation_options.js"></script>
        <script src="../../../_static/jquery.js"></script>
        <script src="../../../_static/underscore.js"></script>
        <script src="../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../_static/doctools.js"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            NL2Declare
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../modules.html">nl2declare</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">NL2Declare</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../nl2declare.html">nl2declare</a></li>
      <li class="breadcrumb-item active">nl2declare.utils.word_classes</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for nl2declare.utils.word_classes</h1><div class="highlight"><pre>
<div class="viewcode-block" id="WordClasses"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses">[docs]</a><span></span><span class="k">class</span> <span class="nc">WordClasses</span><span class="p">:</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">MANDATORY_MODALS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;must&quot;</span><span class="p">,</span> <span class="s2">&quot;will&quot;</span><span class="p">,</span> <span class="s2">&quot;would&quot;</span><span class="p">,</span> <span class="s2">&quot;shall&quot;</span><span class="p">,</span> <span class="s2">&quot;should&quot;</span><span class="p">,</span> <span class="s2">&quot;require&quot;</span><span class="p">,</span> <span class="s2">&quot;have to&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">OPTIONAL_MODALS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;can&quot;</span><span class="p">,</span> <span class="s2">&quot;could&quot;</span><span class="p">,</span> <span class="s2">&quot;may&quot;</span><span class="p">,</span> <span class="s2">&quot;might&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">START_VERBS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;start&quot;</span><span class="p">,</span> <span class="s2">&quot;begin&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">END_VERBS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;end&quot;</span><span class="p">,</span> <span class="s2">&quot;finish&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">PROCESS_OBJECTS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;process&quot;</span><span class="p">,</span> <span class="s2">&quot;the process&quot;</span><span class="p">,</span> <span class="s2">&quot;workflow&quot;</span><span class="p">,</span> <span class="s2">&quot;instance&quot;</span><span class="p">,</span> <span class="s2">&quot;case&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">FLOW_VERBS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;require&quot;</span><span class="p">,</span> <span class="s2">&quot;need&quot;</span><span class="p">,</span> <span class="s2">&quot;precede&quot;</span><span class="p">,</span> <span class="s2">&quot;succeed&quot;</span><span class="p">,</span> <span class="s2">&quot;follow&quot;</span><span class="p">,</span> <span class="s2">&quot;occur&quot;</span><span class="p">,</span> <span class="s2">&quot;happen&quot;</span><span class="p">,</span> <span class="s2">&quot;take place&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">REVERSE_CLAUSES</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;first&quot;</span><span class="p">,</span> <span class="s2">&quot;before&quot;</span><span class="p">,</span> <span class="s2">&quot;earlier&quot;</span><span class="p">]</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">REVERSE_MARKERS</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;after&quot;</span><span class="p">,</span> <span class="s2">&quot;later&quot;</span><span class="p">]</span>


<div class="viewcode-block" id="WordClasses.is_mandatory"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_mandatory">[docs]</a>    <span class="k">def</span> <span class="nf">is_mandatory</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">MANDATORY_MODALS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_optional"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_optional">[docs]</a>    <span class="k">def</span> <span class="nf">is_optional</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">OPTIONAL_MODALS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_modal"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_modal">[docs]</a>    <span class="k">def</span> <span class="nf">is_modal</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">is_optional</span><span class="p">(</span><span class="n">modal</span><span class="p">)</span> <span class="ow">or</span> <span class="bp">self</span><span class="o">.</span><span class="n">is_mandatory</span><span class="p">(</span><span class="n">modal</span><span class="p">))</span></div>
    
<div class="viewcode-block" id="WordClasses.is_process_object"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_process_object">[docs]</a>    <span class="k">def</span> <span class="nf">is_process_object</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">PROCESS_OBJECTS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_flow_verb"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_flow_verb">[docs]</a>    <span class="k">def</span> <span class="nf">is_flow_verb</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">FLOW_VERBS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_start_verb"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_start_verb">[docs]</a>    <span class="k">def</span> <span class="nf">is_start_verb</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">START_VERBS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_end_verb"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_end_verb">[docs]</a>    <span class="k">def</span> <span class="nf">is_end_verb</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span><span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">END_VERBS</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_reverse_clause"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_reverse_clause">[docs]</a>    <span class="k">def</span> <span class="nf">is_reverse_clause</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">REVERSE_CLAUSES</span><span class="p">])</span></div>
    
<div class="viewcode-block" id="WordClasses.is_reverse_marker"><a class="viewcode-back" href="../../../nl2declare.utils.html#nl2declare.utils.word_classes.WordClasses.is_reverse_marker">[docs]</a>    <span class="k">def</span> <span class="nf">is_reverse_marker</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">modal</span><span class="p">):</span>
        <span class="k">return</span> <span class="p">(</span><span class="n">modal</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="ow">in</span> <span class="p">[</span><span class="n">m</span><span class="o">.</span><span class="n">lower</span><span class="p">()</span> <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">REVERSE_MARKERS</span><span class="p">])</span></div></div>
    
    
    

    
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2024, Pia Halkour, Marc Ludevid Wulf, Julian Kofferath.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>